// ==================== MSP430F4xxx Ÿ̸_A0 ׽Ʈ α׷ =================
//  CPU : MSP430F4250
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : IAR-MSP430
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(7.995392MHz)
//            SMCLK: DCO(7.995392MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include "msp430x42x0.h"
#include <stdio.h>

// Լ 
void cpu_setup(void);						// CPU ʱȭ
void Set_TimerA0(void);						// Ÿ̸ A0 

//  

// ===============================  α׷ ==============================
// [μ]: void
// []: P1.0 : 9.9792ms  
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();						// cpuʱȭ
	_EINT();						// Enable interrupts

	P1DIR = 0x01;						// Port1.0 Output
	while(1){
		_NOP();
	}
}

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned dly;

	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	for(dly = 0; dly < 0x4000U; dly++) ;			// XTAL  ð 

	SCFI0 |= FN_3;						// Set DCO operating range
	SCFQCTL = 121;						// (121+1) x 32768(ACLK) x 2 = 7.99 Mhz
	FLL_CTL0 = DCOPLUS + XCAP18PF;				// DCO+ set so freq = xtal x D x N+1

	Set_TimerA0();						// Timer0 (10.036ms)
}

// ================================== TimerA0  ============================
// [μ] void
// [] 32.768KHz / 327 = 100.2Hz(9.9792ms)
// ----------------------------------------------------------------------------
void Set_TimerA0(void)
{
// TASSELx : Timer Clock Source ACLK(01)
// TACLR : TimerA Clear
// MCx   : Continuos mode : The timer counts up to 0xffffh(10)
	TACTL = TASSEL0 + TACLR + MC1;				// ACLK, continous mode
// CCIE : Capture/Compare Interrupt enable
	CCTL0 = CCIE;						// CCR0 interrupt enabled
 	CCR0 = 327;						// 9.9792ms
}

// ============================ Timer A0 interrupt ============================
// [μ] void
// ----------------------------------------------------------------------------
#pragma vector=TIMERA0_VECTOR
__interrupt void Timer_A (void)
{
 	CCR0 += 327;						// 9.9792ms
	P1OUT ^= 0x01;						// Toggle P1.0
}
