// ================= MSP430F4xxx Ÿ̸_A PWM ׽Ʈ α׷ =================
//  CPU : MSP430F4250
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : IAR-MSP430
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(7.995392MHz)
//            SMCLK: DCO(7.995392MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include "msp430x42x0.h"
#include <stdio.h>

//  

// Լ 
void cpu_setup(void);						// CPU ʱȭ
void Set_TimerA(void);						// Timer_A PWM 

//  

// ===============================  α׷ ==============================
// [μ]: void
// []: P1.2: CCR1 - 75% PWM     
//         P1.3: CCR2 - 25% PWM     
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();						// cpuʱȭ
	_EINT();						// Enable interrupts
	
	P1DIR |= 0x0C;                       			// P1.2 and P1.3 output
	P1SEL |= 0x0C;                       			// P1.2 and P1.3 TA1/2 otions
	while(1){
		_NOP();
	}
}

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned dly;
	
	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	for(dly = 0; dly < 0x4000U; dly++) ;			// XTAL  ð 

	SCFI0 |= FN_3;						// Set DCO operating range
	SCFQCTL = 121;						// (121+1) x 32768(ACLK) x 2 = 7.99 Mhz
	FLL_CTL0 = DCOPLUS + XCAP18PF;				// DCO+ set so freq = xtal x D x N+1

	Set_TimerA();						// Timer_A PWM 
}

// =============================== TimerA PWM  ============================
// [μ] void
// [] SMCLK: 16Mhz
// ----------------------------------------------------------------------------
void Set_TimerA(void)
{
// TASSELx : Timer Clock Source SMCLK(10)
// TACLR : TimerA Clear
// MCx   : Continuos mode : The timer UP Mode(01)
	TACTL = TASSEL1 + TACLR + MC0;				// SMCLK, continous mode

	CCR0 = 512-1;						// PWM Period
	CCTL1 = OUTMOD_7;					// CCR1 reset/set
	CCR1 = 384;						// CCR1 PWM duty cycle
	CCTL2 = OUTMOD_7;					// CCR2 reset/set
	CCR2 = 128;						// CCR2 PWM duty cycle
}
