// ============================ MSP430F4xxx A/D16 CH0 =========================
//  CPU : MSP430F4250
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : mspgcc+Dev-C++
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(1MHz)
//            SMCLK: DCO(1MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include <io.h>
#include <stdio.h>
#include <signal.h>
#include <iomacros.h>

//  
//  
#define RXD	0x02						// RXD on P1.1
#define TXD	0x01						// TXD on P1.0

// Լ 
void cpu_setup(void);						// CPU ʱȭ

void adc16_set(void);						// ADC12 

//  
volatile unsigned adc16_data;					// analog16 interrupt data
volatile int adc16_int_flg = 0;					// analog12 interrupt flag

// ===============================  α׷ ==============================
// [μ] void
// [] A/D Input 16Bit A0+(P6.0),A0-(P6.1) : 0 - Vref(1.2V) 
// ---------------------------------------------------------------------------
int main(void)
{
unsigned datau;	

	cpu_setup();						// cpuʱȭ
	adc16_set();						// ADC16 
	_EINT();						// Enable interrupts
	while(1){
		adc16_int_flg = 0;
		SD16CCTL0 |= SD16SC;				// Set bit to start conversion
		while(adc16_int_flg == 0);
		datau = adc16_data;
	}
}

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned dly;

	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	for(dly = 0; dly < 0x4000U; dly++) ;			// XTAL  ð 

	FLL_CTL0 = DCOPLUS + XCAP18PF;				// DCO+ set so freq = xtal x D x N+1
//	SCFI0 |= FN_4;						// Set DCO operating range
//	SCFQCTL = 121;						// (121+1) x 32768(ACLK) x 2 = 7.99 Mhz
}

// ============================== ADC10  ==================================
// [μ] void
// [] VR+ : AVcc, VR- = AVss
// ----------------------------------------------------------------------------
void adc16_set(void)
{
unsigned dly;

	SD16CTL = SD16REFON+SD16SSEL0;				// 1.2V ref, SMCLK
	SD16CCTL0 |= SD16SNGL+SD16UNI+SD16IE+SD16XOSR+SD16OSR0;// Single conv, enable interrupt,1024 OSR(SD16XOSR+SD16OSR0)
	SD16INCTL0 |= SD16INTDLY_0;				// Interrupt on 4th sample

	for (dly = 0; dly < 0x4000U; dly++);			// Delay for 1.2V ref startup
}

// ============================== ADC16 interrupt =============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt (SD16_VECTOR)SD16_ISR(void)
{
	switch (SD16IV)
	{
		case 2:						// SD16MEM Overflow
			break;
		case 4:						// SD16MEM0 IFG
			adc16_data = SD16MEM0;			// Move results, IFG is cleared
			adc16_int_flg = 1;			// a/d data flag on
			break;
	}
}
